/*
 * EditSquare.java
 *
 * Created on 23 lipiec 2001, 16:25
 */

/**
 *
 * @author  k
 */

import java.awt.*;
import java.awt.event.*;
import java.awt.Graphics2D.*;
import javax.swing.*;
import java.util.*;
  

  public class EditSquare extends JComponent
    {
        Image obraz;
        Graphics2D graphics2D;
        
        public EditPoint editPoint = null;
  
        private int stare_x;
        private int stare_y;
        private int aktualne_x;
        private int aktualne_y;
        private int aktualny_punkt;
        
        private double x_min;
        private double x_max;
        private double y_min;
        private double y_max;
        
       // public Container zawartosc;
        public EditSquareBackground editSquareBackground;
        
        public void setEditPoints(Curve c)
        {
            this.removeAll();
            for (int i=0; i<c.Points.length; i++)
            {
                EditPoint ed = new EditPoint();
                this.add(ed);
                ed.num = i;
                ed.setLocation(this.getPixelX(c.Points[i]), this.getPixelY(c.Points[i]));                
            }
        }
        
        public int getPixelX(MhPoint p)
        {  
            if ((p.GetX()>=x_min)&&(p.GetX()<=x_max))
            {
                double answer;
                answer = ((double)this.getWidth());
                answer *=(((double)p.GetX())-x_min)/(x_max-x_min);
                return (int)answer;
            }
            else
            {
                return -1; //punkt na pewno poza obszarem wyswietlania
            }
        }
        
        public void setMinY(double y)
        {
            this.y_min = y;
        }
        public void setMinX(double x)
        {
            this.x_min = x;
        }
        public void setMaxY(double y)
        {
            this.y_max = y;
        }
        public void setMaxX(double x)
        {
            this.x_max = x;
        }
         
        public int getPixelY(MhPoint p)
        {           
            if ((p.GetY()>=y_min)&&(p.GetY()<=y_max))
            {
                double answer;
                answer = ((double)this.getHeight());
                answer *=(((double)p.GetY())-y_min)/(y_max-y_min);
                return this.getHeight()-(int)answer;
            }
            else
            {
                return -1; //punkt na pewno poza obszarem wyswietlania
            }
        }
        
        public EditSquare(Dimension d){
            super();
            setDoubleBuffered(false);
            this.setMinimumSize(new Dimension(100, 100));
            this.setSize(d);
            this.setLayout(null);
            this.aktualny_punkt = -1;
            
            editSquareBackground = new EditSquareBackground(d);
            editSquareBackground.setSize(d);
          //  editPoint = new EditPoint();
           // this.editPoint.setLocation(20,20);
           // this.add(editPoint);
                      
           // this.editPoint.setVisible(true);
           // this.add(editSquareBackground);
            
            editSquareBackground.setSize(d);
            
            System.out.println("EditSquare() fired!");
            System.out.println(d);
            System.out.println(this.getSize());      
            System.out.println(this.editSquareBackground.getSize());      

            addMouseListener(new MouseAdapter(){
               public void mousePressed(MouseEvent e){
                   stare_x = e.getX();
                   stare_y = e.getY();       
                   System.out.println(stare_x);
                   System.out.println(stare_y);
                   String s = (getComponentAt(stare_x,stare_y)).toString();
                   
                   editPoint = null;
                   
                   if(getComponentAt(stare_x, stare_y) instanceof EditPoint)                   
                   {
                        editPoint = (EditPoint) getComponentAt(stare_x,stare_y);
                   }
                   
                   System.out.println(s);
                   System.out.println(this.toString());
              }
            });
            addMouseMotionListener(new MouseMotionAdapter(){
                    public void mouseDragged(MouseEvent e){
                        aktualne_x = e.getX();
                        aktualne_y = e.getY();

                        if (editPoint!=null)
                        {
                            editPoint.setLocation(aktualne_x,aktualne_y);
                        }
                        
                        stare_x = aktualne_x;
                        stare_y = aktualne_y;

                        System.out.println("MouseDragged");
                        
                        repaint();
                    }
            });
        }        
        public void paintComponent(Graphics g)
        {
            System.out.println("EditSquare: paintComponent() fired !");
           // this.setSize(tmp_x, tmp_y);
            if (obraz == null)
            {
                obraz = createImage(this.getWidth(), this.getHeight());
    
                System.out.println("Square : obraz==null, ");
                System.out.println(this.getWidth());
                System.out.println(this.getHeight());
                    graphics2D = (Graphics2D) obraz.getGraphics();
                graphics2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING, 
                    RenderingHints.VALUE_ANTIALIAS_ON);
                czysc();
            }          
            g.drawImage(obraz, 0, 0, null);
            int i = this.getComponentCount()-1;
            for (; i>=0; i--)
            {
                Component c = this.getComponent(i);
                c.paint(g);
            }
        }
        public void czysc()
        {
            graphics2D.setPaint(Color.white);
           // graphics2D.fillRect(0,  0,  getSize().width, getSize().height);
            System.out.println("Square : czysc() fired!");
            System.out.println(getSize().width);
            graphics2D.setPaint(Color.black);
            repaint();
        }
    }