import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
class NeuralNetEditor extends JFrame implements ActionListener{	
        EditSigmoidNeuron editSigmoidNeuronDialog;
        EditSigmoidUnipolarNeuron editSigmoidUnipolarNeuronDialog;
        EditSinNeuron editSinNeuronDialog;
        EditRndNeuron editRndNeuronDialog;
        EditDiffNeuron editDiffNeuronDialog;
        EditConstNeuron editConstNeuronDialog;
        EditThresholdNeuron editThresholdNeuronDialog;
        AddNeuronDialog addNeuronDialog;
        EditConnection editConnectionDialog;
        OptimizationDialog optimizationDialog;
        
        Network network = new Network();
        JMenu editorFileMenu = new JMenu("File");
        JMenu editorOptimizeMenu = new JMenu("Optimize");
        JMenuItem itemLoadNetwork = new JMenuItem("Load Network...");
        JMenuItem itemSaveNetwork = new JMenuItem("Save Network...");
        JMenuItem itemOptimizeNetwork = new JMenuItem("Optimize Network...");
        JMenuItem itemOneStep = new JMenuItem("One Step");
        JMenuItem itemMultipleSteps = new JMenuItem("Multiple Steps");
        JMenuItem itemShowWaveforms = new JMenuItem("Show Waveforms");
        JMenuBar editorMenuBar = new JMenuBar();
        
        EditArea zawartosc;
                
        int considerSteps = 100;
        int randomSearchTrials = 100;
        
        int stare_x = 0;
        int stare_y = 0;
        
        
        
        int aktualne_x = 0;
        int aktualne_y = 0;
        
        NeuronIcon ic = new NeuronIcon();
        
        public void SetNeuronIcons()
        {
            zawartosc.removeAll();
            for (int i=0; i<network.nNeurons; i++)
            {
                NeuronIcon ico = new NeuronIcon();
                this.zawartosc.add(ico);
                ico.setLocation(network.Neurons[i].x,network.Neurons[i].y);
                ico.SetNumber(i);
                if (network.Neurons[i] instanceof SigmoidNeuron)
                {
                    ico.SetName("N");
                }
                else if (network.Neurons[i] instanceof SigmoidUnipolarNeuron)
                {
                    ico.SetName("Nu");
                }
                else if (network.Neurons[i] instanceof SinNeuron)
                {
                    ico.SetName("Sin");
                }
                else if (network.Neurons[i] instanceof DiffNeuron)
                {
                    ico.SetName("Diff");
                }
                else if (network.Neurons[i] instanceof ThresholdNeuron)
                {
                    ico.SetName("Thr");
                }
                else if (network.Neurons[i] instanceof RndNeuron)
                {
                    ico.SetName("Rnd");
                }
                else if (network.Neurons[i] instanceof ConstNeuron)
                {
                    ico.SetName("*");
                }
                
                
                
                ico.SetNetwork(network);
                ico.SetEditor(this);
                ico.num = i;
            }
            for (int i=0; i<network.nWires; i++)
            {
                int x,y,n;
                n = network.Wires[i].from;
                x = network.Neurons[n].x+50;
                y = network.Neurons[n].y+20;
                Point a = new Point(x,y);
                n = network.Wires[i].to;
                x = network.Neurons[n].x-10;
                y = network.Neurons[n].y+20;
                Point b = new Point(x,y);                
                ConnectionIcon con = new ConnectionIcon(a,b);
                con.SetWeight(network.Wires[i].weight);
                con.setLocation(con.GetCenterPoint());
                con.SetNetwork(network);
                con.SetEditor(this);
                con.num = i;
                this.zawartosc.add(con);
            }
            
        }       
        
        
        
	public NeuralNetEditor() {
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				dispose();
				System.exit(0);
			}
                        public void windowActivated(WindowEvent e)
                        {
                            System.out.println("window scaled");
                        }
		});
                addComponentListener(new ComponentAdapter() {
                    
                    public void componentResized(ComponentEvent e)
                    {
                        System.out.println("Component resized");
                        ResizeEditArea();
                    }
                    
                });
                
                
           /*   addMouseListener(new MouseAdapter(){
               public void mousePressed(MouseEvent e){
                   stare_x = e.getX();
                   stare_y = e.getY();       
                   System.out.println(stare_x);
                   System.out.println(stare_y);
                   String s = (getComponentAt(stare_x,stare_y)).toString();
                   
                   ic = null;
                   
                   if(getComponentAt(stare_x, stare_y) instanceof NeuronIcon)                   
                   {
                       System.out.println("you clicked on an neuron");
                        ic = (NeuronIcon) getComponentAt(stare_x,stare_y);
                   }
                   
                   System.out.println(s);
                   System.out.println(this.toString());
              }
            });
            
             addMouseMotionListener(new MouseMotionAdapter(){
                    public void mouseDragged(MouseEvent e){
                        aktualne_x = e.getX();
                        aktualne_y = e.getY();
                                           
                        if (ic!=null)
                        {
                            ic.setLocation(aktualne_x,aktualne_y);
                        }
                        
                        System.out.println("Aktualne wspolrzedne");
                        System.out.println(aktualne_x);
                        System.out.println(aktualne_y);
                        
                        stare_x = aktualne_x;
                        stare_y = aktualne_y;
                        System.out.println("MouseDragged");    
                        repaint();
                    }
            });
            */
                
             this.setJMenuBar(editorMenuBar);
             this.setSize(400, 400);
             this.setTitle("Neural Net Editor");
                
            // NeuronIcon ico = new NeuronIcon();
             zawartosc = new EditArea(new Dimension(1400,1400));
             zawartosc.setNeuralNetEditor(this);
             this.getContentPane().add(zawartosc);
           //  zawartosc.add(ico);
             this.setBackground(Color.WHITE);
             this.getContentPane().setBackground(Color.WHITE);
           //  ico.setLocation(40,50);
           //  ico.SetName("Nu");
             zawartosc.setBackground(Color.WHITE);
             zawartosc.setLayout(null);
         
            editorFileMenu.add(itemLoadNetwork);        
            editorFileMenu.add(itemSaveNetwork);
            editorOptimizeMenu.add(itemOptimizeNetwork);
            editorOptimizeMenu.add(itemShowWaveforms);
            editorMenuBar.add(editorFileMenu);    
            editorMenuBar.add(editorOptimizeMenu);
            editorMenuBar.add(itemOneStep);
            editorMenuBar.add(itemMultipleSteps);
           
            itemLoadNetwork.addActionListener(this);
            itemSaveNetwork.addActionListener(this);
            itemShowWaveforms.addActionListener(this);
            itemOneStep.addActionListener(this);
            itemMultipleSteps.addActionListener(this);
            itemOptimizeNetwork.addActionListener(this);
            
            network = new Network();
            network.EraseNetwork();
            editSigmoidNeuronDialog = new EditSigmoidNeuron(this,true);
            editSigmoidUnipolarNeuronDialog = new EditSigmoidUnipolarNeuron(this,true);
            editSinNeuronDialog = new EditSinNeuron(this,true);
            editRndNeuronDialog = new EditRndNeuron(this,true);
            editThresholdNeuronDialog = new EditThresholdNeuron(this,true);
            editDiffNeuronDialog = new EditDiffNeuron(this,true);
            editConstNeuronDialog = new EditConstNeuron(this,true);
            addNeuronDialog = new AddNeuronDialog(this,true);
            editConnectionDialog = new EditConnection(this,true);
            addNeuronDialog.setNeuralNetEditor(this);
            optimizationDialog = new OptimizationDialog(this,true);
            optimizationDialog.SetNeuralNetEditor(this);
	}
        
        private void ResizeEditArea()
        {
            if(zawartosc!=null)
            {
             /*   this.zawartosc.setSize(this.getSize());
                this.zawartosc.repaint();
                System.out.println(this.getSize());
                System.out.println(this.zawartosc.getSize());*/
            }
        }
        
        private void TakeOneStep()
        {
            if (this.network != null)
            {
                this.network.TakeStep(true);
            }
        }
        private void TakeMultipleSteps()
        {
            if (this.network != null)
            {
                this.network.TakeSteps(this.considerSteps, true);
            }
        } 
        private void odczytSieci()
        {
                String path="";
                    JFileChooser otwieranie = new JFileChooser();
                    otwieranie.setAcceptAllFileFilterUsed(false);
                    ExampleFileFilter filter = new ExampleFileFilter(new String("nnt"),"Neural Net Files");
                    otwieranie.addChoosableFileFilter(filter);
                    otwieranie.setMultiSelectionEnabled(false);
                   //  otwieranie.setFileFilter("nnt");
                    int wynik = otwieranie.showOpenDialog(this);
                    if (wynik == JFileChooser.CANCEL_OPTION) return;
                    try{
                        path = otwieranie.getSelectedFile().getAbsolutePath();
                        System.out.println(path);
                        network.KillWaveforms();
                        network.ReadFromFile(path);
                        network.ShowWaveforms();
                        this.SetNeuronIcons();
                        path = otwieranie.getSelectedFile().getName();
                        this.setTitle("NeuralNetEditor - "+path);
                    }
                    catch(Exception e){
                        System.out.println(e);
                    }
        }    
        
        private void optymalizuj()
        {
            this.optimizationDialog.show();
        }
        private void zapisSieci()
        {
                String path="";
                    JFileChooser otwieranie = new JFileChooser();
                    otwieranie.setAcceptAllFileFilterUsed(false);
                     ExampleFileFilter filter = new ExampleFileFilter(new String("nnt"),"Neural Net Files");
                    otwieranie.addChoosableFileFilter(filter);
                    otwieranie.setMultiSelectionEnabled(false);
              //       otwieranie.setFileFilter("nnt");
                    int wynik = otwieranie.showSaveDialog(this);
                    if (wynik == JFileChooser.CANCEL_OPTION) return;
                    try{
                        
                        path = otwieranie.getSelectedFile().getAbsolutePath();
                        if (!path.endsWith(".nnt"))
                        {
                            path = path + ".nnt";
                        }
                        System.out.println(path);
                        network.SaveToFile(path);
                    }
                    catch(Exception e){
                        System.out.println(e);
                    }
        }
        public void actionPerformed(ActionEvent e)
        {
            String polecenie = e.getActionCommand();
            System.out.println(e.getActionCommand());
            if (polecenie.equals("Load Network..."))
            {
                this.odczytSieci();
            } else if (polecenie.equals("Save Network..."))
            {
                this.zapisSieci();
            }
            else if (polecenie.equals("Show Waveforms"))
            {
                this.network.KillWaveforms();
                this.network.ShowWaveforms();
            }
            else if (polecenie.equals("One Step"))
            {
                this.TakeOneStep();
            }
            else if (polecenie.equals("Multiple Steps"))
            {
                this.TakeMultipleSteps();
            }
            else if (polecenie.equals("Optimize Network..."))
            {
                this.optymalizuj();
            }
        }       
	public static void main(String args[]) 
        {
            new NeuralNetEditor().setVisible(true);            
	}
}
