
/*
 * SigmoidNeuron.java
 *
 * Created on 16 lipiec 2001, 16:04
 */

/**
 *
 * @author  k
 */
public class SigmoidNeuron extends Neuron {

    private double state = 0;
    private double velocity = 0;
    public double sigmo = 0;
    public double force = 0;
    public double inertia = 0;
    private double tmp = 0;
    private double NEURO_MAX = 10.0;
    public String Name="N";
    
    public SigmoidNeuron(double sigmo, double force, double inertia) {
        waveDisplay = new WaveformWindow();
        waveDisplay.SetNeuronName(Name);
        this.sigmo = sigmo;
        this.force = force;
        this.inertia = inertia;     
    }
    
    public SigmoidNeuron(double sigmo, double force, double inertia, WaveformWindow waveDisplay) {
        //waveDisplay = new WaveformWindow();
        //waveDisplay.SetNeuronName(Name);
        this.waveDisplay = waveDisplay;
        this.sigmo = sigmo;
        this.force = force;
        this.inertia = inertia;     
    }
    
    public void AddRandom()
    {
        java.util.Random rnd = new java.util.Random(System.currentTimeMillis());
        this.sigmo += 0.1 - 0.2*rnd.nextDouble();
        this.force += 0.1 - 0.2*rnd.nextDouble();
        this.inertia += 0.1 - 0.2*rnd.nextDouble();
    }
    
    double Evaluate() {
        double input = activation();
        velocity = force*(input-state)+inertia*velocity;
        state+=velocity;
        if (state > NEURO_MAX)
        {
            state = NEURO_MAX;   
        }
        else
        {
            if (state<-NEURO_MAX)
            {
                state = -NEURO_MAX;
            }
        }
        tmp = state*sigmo;
        if (tmp< -30.0) 
        {
            Output = -1;
            
        }
        else
        {
            Output = (2.0 / (1.0 + Math.exp(-tmp)) -1.0);
        }
        return Output;
    }  
}